﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using Infragistics.Controls.Charts;

namespace SilverlightApplication13
{
    public partial class MainPage : UserControl
    {
        StackedData stackedData = new StackedData();
        public MainPage()
        {
            InitializeComponent();
        }

        private void btnPlotStackedColumnChart_Click(object sender, RoutedEventArgs e)
        {
            //Create the axes supported by the StackedColumnSeries
            CategoryXAxis xAxis = new CategoryXAxis();
            xAxis.ItemsSource = stackedData;
            xAxis.Label = "{CategoryLabel}";
            NumericYAxis numYAxis = new NumericYAxis();

            //Add the axes to the Chart
            this.Chart1.Axes.Add(xAxis);
            this.Chart1.Axes.Add(numYAxis);

            //Create the StackFragments
            StackedFragmentSeries stackedFragment1 = new StackedFragmentSeries();
            stackedFragment1.ValueMemberPath = "Series1";
            StackedFragmentSeries stackedFragment2 = new StackedFragmentSeries();
            stackedFragment2.ValueMemberPath = "Series2";
            StackedFragmentSeries stackedFragment3 = new StackedFragmentSeries();
            stackedFragment3.ValueMemberPath = "Series3";
            StackedFragmentSeries stackedFragment4 = new StackedFragmentSeries();
            stackedFragment4.ValueMemberPath = "Series4";

            //Create the StackedColumnSeries and add it to the Chart
            StackedColumnSeries stackedColumnSeries = new StackedColumnSeries();
            stackedColumnSeries.XAxis = xAxis;
            stackedColumnSeries.YAxis = numYAxis;
            stackedColumnSeries.ItemsSource = stackedData;
            stackedColumnSeries.Series.Add(stackedFragment1);
            stackedColumnSeries.Series.Add(stackedFragment2);
            stackedColumnSeries.Series.Add(stackedFragment3);
            stackedColumnSeries.Series.Add(stackedFragment4);
            this.Chart1.Series.Add(stackedColumnSeries);
        }

    }

    public class Category
    {
        public string CategoryLabel { get; set; }
        public double Series1 { get; set; }
        public double Series2 { get; set; }
        public double Series3 { get; set; }
        public double Series4 { get; set; }
    }

    public class StackedData : ObservableCollection<Category>
    {
        public StackedData()
        {
            Add(new Category { CategoryLabel = "Stack1", Series1 = 20, Series2 = 40, Series4 = -20, Series3 = 20 });
            Add(new Category { CategoryLabel = "Stack2", Series1 = -20, Series2 = -30, Series4 = 25, Series3 = 35 });
            Add(new Category { CategoryLabel = "Stack3", Series1 = -20, Series2 = 25, Series4 = -20, Series3 = 35 });
            Add(new Category { CategoryLabel = "Stack4", Series1 = 10, Series2 = 20, Series4 = 30, Series3 = 40 });
            Add(new Category { CategoryLabel = "Stack5", Series1 = -25, Series2 = -25, Series4 = -25, Series3 = -25 });
            Add(new Category { CategoryLabel = "Stack6", Series1 = -25, Series2 = 25, Series4 = 50, Series3 = 10 });
            Add(new Category { CategoryLabel = "Stack7", Series1 = 20, Series2 = 20, Series4 = 40, Series3 = -40 });

        }
    }
}
